//+------------------------------------------------------------------+
//|                                                   VisualBars.mq5 |
//|                                                            Graff |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Graff"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window

#property indicator_buffers 5
#property indicator_plots   5
//---- plot buffer 1
#property indicator_label1  "Open;High;Low;Close"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrGreen,clrRed
//#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//#property indicator_levelwidth1  3

//#include <ChartObjects\ChartObjectsLines.mqh>
#include <Arrays\ArrayString.mqh>
#include <ChartObjects\ChartObjectsTxtControls.mqh>
#include <Arrays\List.mqh>
//#include <ChartObjectExtControls.mqh> // TF spinner

bool     InpMarketWatch=true; //  " "  
input ENUM_TIMEFRAMES inp_tf=0; //TimeFrame

CArrayString      SymbolList;

//Buffers
double bOpen[],bHigh[],bLow[],bClose[];
double bClr[];

//CChartObjectHLine *horizont;
//CChartObjectTrend *horizont;
CChartObjectLabel *coord;

CChartObjectText *Lable;
//CChartObjectLabel *Lable;
CList    Objects;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   int count=SymbolsTotal(InpMarketWatch);
   SymbolList.Clear();
   for(int i=0;i<count;i++) SymbolList.Add(SymbolName(i,InpMarketWatch));
   if(SymbolList.Total()<=0) Print("Unable to get symbol list!");
// Creating +
   coord=new CChartObjectLabel();
   coord.Create(0,"Coord",0,iTime(Symbol(),Period(),SymbolList.Total()+3),iClose(Symbol(),Period(),0));
   coord.Color(clrLimeGreen);
   coord.Description("+");
   coord.Anchor(ANCHOR_LEFT);
   coord.Selectable(true);
   Objects.Add(coord);
//coord.Time
// Creating ------
//horizont=new CChartObjectHLine();
/*   horizont=new CChartObjectTrend();
   horizont.Create(0,"HLine",0,iTime(Symbol(),Period(),SymbolList.Total()),iClose(Symbol(),Period(),0),iTime(Symbol(),Period(),0),iClose(Symbol(),Period(),0));
//horizont.Create(0,"HLine",0,iClose(Symbol(),Period(),0));
   horizont.Color(clrLimeGreen);
   horizont.Style(STYLE_SOLID);
   horizont.Selectable(false);*/

//--- indicator buffers mapping
   SetIndexBuffer(0,bOpen,INDICATOR_DATA);
   SetIndexBuffer(1,bHigh,INDICATOR_DATA);
   SetIndexBuffer(2,bLow,INDICATOR_DATA);
   SetIndexBuffer(3,bClose,INDICATOR_DATA);
   SetIndexBuffer(4,bClr,INDICATOR_COLOR_INDEX);

   ArrayInitialize(bOpen,EMPTY_VALUE);
   ArrayInitialize(bHigh,EMPTY_VALUE);
   ArrayInitialize(bLow,EMPTY_VALUE);
   ArrayInitialize(bClose,EMPTY_VALUE);
//ArrayInitialize(v,EMPTY_VALUE);
//--- set accuracy
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//--- sets first bar from what index will be drawn
//PlotIndexSetInteger(0,PLOT_SHIFT,TerminalInfoInteger(TERMINAL_MAXBARS)-SymbolList.Total());

//---
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//
// indicator moving block
   datetime coord_last_dt=0;
   double coord_last_price=0;
   double r[];
      CopyClose(Symbol(),Period(),coord.Time(0),TimeCurrent(),r);
      PlotIndexSetInteger(0,PLOT_SHIFT,TerminalInfoInteger(TERMINAL_MAXBARS)-ArraySize(r)+2);   
      PlotIndexSetInteger(1,PLOT_SHIFT,TerminalInfoInteger(TERMINAL_MAXBARS)-ArraySize(r)+2);
      PlotIndexSetInteger(2,PLOT_SHIFT,TerminalInfoInteger(TERMINAL_MAXBARS)-ArraySize(r)+2);
      PlotIndexSetInteger(3,PLOT_SHIFT,TerminalInfoInteger(TERMINAL_MAXBARS)-ArraySize(r)+2);
      PlotIndexSetInteger(4,PLOT_SHIFT,TerminalInfoInteger(TERMINAL_MAXBARS)-ArraySize(r)+2);
      ChartRedraw();
   if(coord_last_dt!=coord.Time(0) || coord_last_price!=coord.Price(0) || NewBar(Period()))
     {

      //PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,TerminalInfoInteger(TERMINAL_MAXBARS)-ArraySize(r)+4);
      ArrayInitialize(bOpen,EMPTY_VALUE);
      ArrayInitialize(bHigh,EMPTY_VALUE);
      ArrayInitialize(bLow,EMPTY_VALUE);
      ArrayInitialize(bClose,EMPTY_VALUE);

      
      coord_last_dt=coord.Time(0);
      coord_last_price=coord.Price(0);
     }

   for(int i=0;i<SymbolList.Total();i++)
     {
      long digits=SymbolInfoInteger(SymbolList.At(i),SYMBOL_DIGITS);
      //Comment(digits);
      uint delim=1;
      if(_Digits>digits)
        {
         for(uint j=0;j<_Digits-digits;j++)
           {
            delim*=10;
           }
        }
      bOpen[i]=coord.Price(0);
      bHigh[i]=coord.Price(0)+((iHigh(SymbolList.At(i),inp_tf,0)-iOpen(SymbolList.At(i),inp_tf,0)))/delim;
      bLow[i]=coord.Price(0)-((iOpen(SymbolList.At(i),inp_tf,0)-iLow(SymbolList.At(i),inp_tf,0)))/delim;
      bClose[i]=coord.Price(0)-((iOpen(SymbolList.At(i),inp_tf,0)-iClose(SymbolList.At(i),inp_tf,0)))/delim;
/*
      bOpen[i]=iOpen(Symbol(),Period(),i);
      bHigh[i]=iHigh(Symbol(),Period(),i);
      bLow[i]=iLow(Symbol(),Period(),i);
      bClose[i]=iClose(Symbol(),Period(),i);
*/
      Lable=new CChartObjectLabel();
      if(iClose(SymbolList.At(i),inp_tf,0)>iOpen(SymbolList.At(i),inp_tf,0))
        {
         bClr[i]=0;
         Lable.Create(0,SymbolList.At(i),0,iTime(Symbol(),Period(),ArraySize(r)-i-3),bLow[i]);
         Lable.Anchor(ANCHOR_RIGHT);
         Lable.Angle(90);
         //Lable.Description("hjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj");
        }
      else
        {
         bClr[i]=1;
         Lable.Create(0,SymbolList.At(i),0,iTime(Symbol(),Period(),ArraySize(r)-i-3),bHigh[i]);
         Lable.Anchor(ANCHOR_LEFT);
         Lable.Angle(90);
        }
      Lable.Description(SymbolList.At(i));
      Lable.Color(clrWhite);
      Lable.FontSize(7);
      Lable.Font("Tahoma");
Lable.Selectable(true);

      Objects.Add(Lable);
      //Lables.Anchor(ANCHOR_CENTER);
     }
   ArrayFree(r);
//Comment("");
//Comment(iLow(Symbol(),Period(),0));
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
double iOpen(string symbol,ENUM_TIMEFRAMES tf,int index)
  {
   if(index<0) return(-1);
   double Arr[1];
   if(CopyOpen(symbol,tf,index,1,Arr)>0)
      return(Arr[0]);
   else return(-1);
  }
//+------------------------------------------------------------------+
double iHigh(string symbol,ENUM_TIMEFRAMES tf,int index)
  {
   if(index<0) return(-1);
   double Arr[1];
   if(CopyHigh(symbol,tf,index,1,Arr)>0)
      return(Arr[0]);
   else return(-1);
  }
//+------------------------------------------------------------------+
double iLow(string symbol,ENUM_TIMEFRAMES tf,int index)
  {
   if(index<0) return(-1);
   double Arr[1];
   if(CopyLow(symbol,tf,index,1,Arr)>0)
      return(Arr[0]);
   else return(-1);
  }
//+------------------------------------------------------------------+
double iClose(string symbol,ENUM_TIMEFRAMES tf,int index)
  {
   if(index<0) return(-1);
   double Arr[1];
   if(CopyClose(symbol,tf,index,1,Arr)>0)
      return(Arr[0]);
   else return(-1);
  }
//+------------------------------------------------------------------+
datetime iTime(string symbol,ENUM_TIMEFRAMES tf,int index)
  {
   if(index<0) return(-1);
   datetime Arr[];
   if(CopyTime(symbol,tf,index,1,Arr)>0)
      return(Arr[0]);
   else return(-1);
  }
//+------------------------------------------------------------------+
//|  NewBar func
//+------------------------------------------------------------------+
bool NewBar(ENUM_TIMEFRAMES period)
  {
   MqlRates rt[];
   if(CopyRates(_Symbol,period,0,1,rt)!=1)
     {
      //Print("CopyRates of ",_Symbol," failed, no history");
      return(false);
     }
   if(rt[0].tick_volume>1) return(false);
   return(true);
  }
//+------------------------------------------------------------------+
